# List allowed components for a placeholder

Retrieves the list of components that can be added to a placeholder on a page. This helps ensure that only compatible components are used in each placeholder.

Endpoint: GET /api/v1/pages/{pageId}/placeholders/{placeholderName}/allowed-components
Version: v2.0
Security: HTTPBearer

## Security:

  - `HTTPBearer` (unknown)
    http bearer JWT

## Path parameters:

  - `pageId` (string, required)
    The unique identifier of the page. To get this ID, use [List pages of a site](#operation/sites-get_all_pages_by_site).

  - `placeholderName` (string, required)
    The unique identifier of the placeholder.

## Query parameters:

  - `language` (any)
    The language code for filtering components.

  - `variantId` (any)
    The unique identifier of the personalization or A/B/n test variant to use. To get this ID, you can use the [List flow definitions](#operation/flows-list_flow_definitions_by_page) endpoint. Use the `transpiledVariants[].ref`, or `variants[].ref` when available.
 
If you provide this value, the list of allowed components is retrieved for the specified variant. If you omit this value, the list for the base page is returned.

## Header parameters:

  - `x-sc-job-id` (any)
    A unique identifier for the job, used to trace, audit, and revert actions performed by an AI agent through the Agent API.

## Response 200:

  - `200` (unknown)
    Successful response

## Response 200 fields (application/json):

  - `id` (string)
    The unique identifier of the component.
    Example: 86a03271-dff4-470a-92bd-b68c67de2e25

  - `name` (string)
    The name of the component.
    Example: Promo

## Response 422:

  - `422` (unknown)
    Unprocessable entity

## Response 422 fields (application/json):

  - `detail` (array)

  - `detail.loc` (array)
    The location of the error in the request.

  - `detail.msg` (string)
    The error message.

  - `detail.type` (string)
    The type of error.

  - `detail.input` (any)
    The input that caused the error.

  - `detail.ctx` (object)
    The context in which the error occurred.

